property pCamera1, pSprite, pCamerasReady, pSpriteLocH
global g3DWorld, mTrack, mSky, mCamera, mFinish, mLight, mRamp1, mRamp2, gCarName, ovTxt, ovFader, ovBackdrop, ovDial_1, ovDial_2, ovWinner_1, ovWinner_2, ovNeedle_1, ovNeedle_2, ovDSLight_1, ovDSLight_2, ovP1Score_1, ovP1Score_2, ovP1Score_3, ovP1Score_4, ovP1Score_5, ovP2Score_1, ovP2Score_2, ovP2Score_3, ovP2Score_4, ovP2Score_5, ovKey_1_1, ovKey_1_2, ovKey_2_1, ovKey_2_2, gP1Finished, gP2Finished, gEventID, gPlayerKeysList, ovResultsPanel_1, ovResultsPanel_2, ovP1Results_1, ovP1Results_2, ovP1Results_3, ovP1Results_4, ovP1Results_5, ovP2Results_1, ovP2Results_2, ovP2Results_3, ovP2Results_4, ovP2Results_5, gGameMODE

on beginSprite me
  pSprite = sprite(me.spriteNum)
  pCamerasReady = 0
  pSpriteLocH = pSprite.locH
  pSprite.locH = 1000
end

on prepareCamera
  pCamera1 = g3DWorld.camera[1]
  mCamera = pCamera1
  if gCarName <> "Rocket" then
    if gCarName = "Jumper" then
      member("sky").posterFrame = 3
    else
      member("sky").posterFrame = 1
    end if
    ovBackdrop = createBackdrop(mCamera, "ovBackdrop", "sky", #rgba8880, 0, #low, 100, point(0, -60), 0)
  end if
  member("countdown").posterFrame = 1
  ovTxt = createOverlay(mCamera, "ovTxt", "countdown", #rgba8888, 0, #low, 100, point(167, 100), 0)
  put gPlayerKeysList
  tkeysList = ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]
  repeat with i = 1 to tkeysList.count
    if gPlayerKeysList[1] = tkeysList[i] then
      member("keys").posterFrame = i
      ovKey_1_1 = createOverlay(mCamera, "ovKey_1_1", "keys", #rgba4444, 0, #low, 30, point(86, 255), 0)
      next repeat
    end if
    if gPlayerKeysList[2] = tkeysList[i] then
      member("keys_ds").posterFrame = i
      ovKey_1_2 = createOverlay(mCamera, "ovKey_1_2", "keys_ds", #rgba4444, 0, #low, 30, point(72, 216), 0)
      next repeat
    end if
    if gPlayerKeysList[3] = tkeysList[i] then
      member("keys").posterFrame = i
      if gGameMODE = 1 then
        ovKey_2_1 = createOverlay(mCamera, "ovKey_2_1", "keys", #rgba4444, 0, #low, 30, point(356, 555), 0)
      else
        ovKey_2_1 = createOverlay(mCamera, "ovKey_2_1", "keys", #rgba4444, 0, #low, 30, point(356, 255), 0)
      end if
      next repeat
    end if
    if gPlayerKeysList[4] = tkeysList[i] then
      member("keys_ds").posterFrame = i
      if gGameMODE = 1 then
        ovKey_2_2 = createOverlay(mCamera, "ovKey_2_2", "keys_ds", #rgba4444, 0, #low, 30, point(342, 516), 0)
        next repeat
      end if
      ovKey_2_2 = createOverlay(mCamera, "ovKey_2_2", "keys_ds", #rgba4444, 0, #low, 30, point(342, 216), 0)
    end if
  end repeat
  member("gameOverlay").posterFrame = gEventID
  ovDial_1 = createOverlay(mCamera, "ovDial_1", "gameOverlay", #rgba8888, 0, #low, 100, point(0, 0), 0)
  ovDSLight_2 = createOverlay(mCamera, "ovDSLight_2", "ds_light", #rgba4444, 0, #low, 0, point(400, 254), 0)
  ovDSLight_1 = createOverlay(mCamera, "ovDSLight_1", "ds_light", #rgba4444, 0, #low, 0, point(130, 254), 0)
  ovWinner_1 = createOverlay(mCamera, "ovWinner_1", "winner", #rgba8888, 0, #low, 0, point(-11, 207), 0)
  ovWinner_2 = createOverlay(mCamera, "ovWinner_2", "winner", #rgba8888, 0, #low, 0, point(259, 207), 0)
  ovNeedle_1 = createOverlay(mCamera, "ovNeedle_1", "speedometer_needle", #rgba8888, 1, #low, 100, point(95, 296), 0)
  ovNeedle_2 = createOverlay(mCamera, "ovNeedle_2", "speedometer_needle", #rgba8888, 1, #low, 100, point(365, 296), 0)
  mCamera.overlay[ovNeedle_1].regPoint = point(64, 8)
  mCamera.overlay[ovNeedle_2].regPoint = point(64, 8)
  member("results").posterFrame = gEventID
  ovResultsPanel_1 = createOverlay(mCamera, "ovResultsPanel_1", "results", #rgba4444, 0, #low, 0, point(24, 110), 0)
  ovResultsPanel_2 = createOverlay(mCamera, "ovResultsPanel_2", "results", #rgba4444, 0, #low, 0, point(265, 110), 0)
  member("numbers_white").posterFrame = 1
  ty = 130 + 7
  tx = 24 + 27
  tspace = 13
  ovP1Results_1 = createOverlay(mCamera, "ovP1Results_1", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 0), ty), 0)
  ovP1Results_2 = createOverlay(mCamera, "ovP1Results_2", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 1), ty), 0)
  ovP1Results_3 = createOverlay(mCamera, "ovP1Results_3", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 2), ty), 0)
  ovP1Results_4 = createOverlay(mCamera, "ovP1Results_4", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 3), ty), 0)
  ovP1Results_5 = createOverlay(mCamera, "ovP1Results_5", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 4), ty), 0)
  ty = 130 + 7
  tx = 265 + 27
  tspace = 13
  ovP2Results_1 = createOverlay(mCamera, "ovP2Results_1", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 0), ty), 0)
  ovP2Results_2 = createOverlay(mCamera, "ovP2Results_2", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 1), ty), 0)
  ovP2Results_3 = createOverlay(mCamera, "ovP2Results_3", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 2), ty), 0)
  ovP2Results_4 = createOverlay(mCamera, "ovP2Results_4", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 3), ty), 0)
  ovP2Results_5 = createOverlay(mCamera, "ovP2Results_5", "numbers_white", #rgba4444, 0, #low, 0, point(tx + (tspace * 4), ty), 0)
  member("numbers_white").posterFrame = 1
  ty = 4
  tx = 60
  tspace = 13
  ovP1Score_1 = createOverlay(mCamera, "ovP1Score_1", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 0), ty), 0)
  ovP1Score_2 = createOverlay(mCamera, "ovP1Score_2", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 1), ty), 0)
  ovP1Score_3 = createOverlay(mCamera, "ovP1Score_3", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 2), ty), 0)
  ovP1Score_4 = createOverlay(mCamera, "ovP1Score_4", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 3), ty), 0)
  ovP1Score_5 = createOverlay(mCamera, "ovP1Score_5", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 4), ty), 0)
  ty = 4
  tx = 330
  tspace = 13
  ovP2Score_1 = createOverlay(mCamera, "ovP2Score_1", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 0), ty), 0)
  ovP2Score_2 = createOverlay(mCamera, "ovP2Score_2", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 1), ty), 0)
  ovP2Score_3 = createOverlay(mCamera, "ovP2Score_3", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 2), ty), 0)
  ovP2Score_4 = createOverlay(mCamera, "ovP2Score_4", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 3), ty), 0)
  ovP2Score_5 = createOverlay(mCamera, "ovP2Score_5", "numbers_white", #rgba4444, 0, #low, 100, point(tx + (tspace * 4), ty), 0)
  ovFader = createOverlay(mCamera, "ovFader", "fader", #rgba4444, 0, #low, 100, point(0, 0), 0)
  case gCarName of
    "Dragster":
      pCamera1.hither = 2
      pCamera1.projectionAngle = 30
      pCamera1.colorBuffer.clearAtRender = 0
      pCamera1.transform.position = vector(0, -10, 10)
      pCamera1.pointAt(vector(0, 20, 0), vector(0, 0, 1))
      pSprite.camera = pCamera1
      g3DWorld.directionalPreset = #topCenter
      pCamerasReady = 1
    "Jumper":
      pCamera1.hither = 2
      pCamera1.projectionAngle = 30
      pCamera1.colorBuffer.clearAtRender = 0
      pCamera1.transform.position = vector(0, -10, 10)
      pCamera1.pointAt(vector(0, 20, 0), vector(0, 0, 1))
      pSprite.camera = pCamera1
      g3DWorld.directionalPreset = #topCenter
      pCamerasReady = 1
    "Rocket":
      pCamera1.hither = 2
      pCamera1.projectionAngle = 30
      pCamera1.colorBuffer.clearAtRender = 1
      pCamera1.fog.enabled = 1
      pCamera1.fog.near = 150
      pCamera1.fog.far = 1000
      pCamera1.fog.color = rgb(105, 105, 255)
      pCamera1.fog.decayMode = #linear
      pCamera1.transform.position = vector(0, -10, 10)
      pCamera1.pointAt(vector(0, 20, 0), vector(0, 0, 1))
      pSprite.camera = pCamera1
      g3DWorld.directionalPreset = #bottomCenter
      pCamerasReady = 1
  end case
  pSprite.locH = pSpriteLocH
end

on exitFrame me
  if pCamerasReady = 1 then
    case gCarName of
      "Dragster":
        cameraPos = pCamera1.transform.position
        pos1 = g3DWorld.model("Collider_1").transform.position.y
        pos2 = g3DWorld.model("Collider_2").transform.position.y
        if gGameMODE = 1 then
          target_y = min(mFinish.transform.position.y - 20, pos1)
        else
          target_y = min(mFinish.transform.position.y - 20, max(pos1, pos2))
        end if
        curDist = target_y - cameraPos.y
        idealDist = 15.0
        stepDist = ((idealDist - curDist) * 0.14999999999999999) + curDist
        pCamera1.transform.position = vector(0, target_y - stepDist, 2)
        pCamera1.pointAt(vector(0, pCamera1.transform.position.y + 20, 1), vector(0, 0, 1))
      "Jumper":
        cameraPos = pCamera1.transform.position
        tModel_1 = g3DWorld.model("Collider_1")
        tModel_2 = g3DWorld.model("Collider_2")
        tPos_1 = tModel_1.transform.position.y
        tPos_2 = tModel_2.transform.position.y
        if (gP1Finished = 0) and (gP2Finished = 0) then
          if tPos_1 > tPos_2 then
            tmodel = tModel_1
          else
            tmodel = tModel_2
          end if
        else
          if (gP1Finished = 1) and (gP2Finished = 1) then
            if tPos_1 > tPos_2 then
              tmodel = tModel_2
            else
              tmodel = tModel_1
            end if
          else
            if gP1Finished = 1 then
              tmodel = tModel_2
            else
              tmodel = tModel_1
            end if
          end if
        end if
        if gGameMODE = 1 then
          target_y = tModel_1.transform.position.y
          target_z = tModel_1.transform.position.z
        else
          target_y = tmodel.transform.position.y
          target_z = tmodel.transform.position.z
        end if
        curDist = target_y - cameraPos.y
        idealDist = 15.0
        stepDist = ((idealDist - curDist) * 0.14999999999999999) + curDist
        pCamera1.transform.position = vector(0, target_y - stepDist, target_z + 1)
        pCamera1.pointAt(vector(0, pCamera1.transform.position.y + 20, target_z), vector(0, 0, 1))
      "Rocket":
        cameraPos = pCamera1.transform.position
        pos1 = g3DWorld.model("Collider_1").transform.position.y
        pos2 = g3DWorld.model("Collider_2").transform.position.y
        if gGameMODE = 1 then
          target_y = pos1
        else
          target_y = max(pos1, pos2)
        end if
        curDist = target_y - cameraPos.y
        idealDist = -18.0
        stepDist = ((idealDist - curDist) * 0.45000000000000001) + curDist
        pCamera1.transform.position = vector(0, target_y - stepDist, 5)
        pCamera1.pointAt(vector(0, pCamera1.transform.position.y - 25, 0), vector(0, 0, -1))
    end case
  end if
end
